package com.example.dpanntout;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import bdd.ClientDAO;
import bdd.InterventionDAO;

public class ModifierLintervention extends AppCompatActivity {
    private int idInter ;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_modifier_lintervention);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });
        Initialisation();
        initialiserChampsIntervention();

        idInter = getIntent().getIntExtra("id", -1); // -1 si problème

    }


    private void Initialisation() {
        //gestion du bouton quitter
        Button btQuitModifInter = (Button) findViewById(R.id.btQuitModifInter);
        //associer l'evenement quitter au boutton quitter
        btQuitModifInter.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        Button btDeleteInter = (Button) findViewById(R.id.btDeleteInter);
        btDeleteInter.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                supprimerIntervention();
            }
        });
        Button saveModifInter = (Button) findViewById(R.id.saveModifInter);
        saveModifInter.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                modifierIntervention();
            }
        });


    }


    //methode qui permet d'afficher dans les champs les données d'une inter selectionner
    private void initialiserChampsIntervention() {
        // Récupérer les données envoyées par l'intent
        Intent intent = getIntent();
        if (intent != null) {
            String numCLient = intent.getStringExtra("idCli");

            String date = intent.getStringExtra("dateTime");
            String observation = intent.getStringExtra("observation");

            // Relier les EditText avec fiche id fichier xml modifier client
            EditText etNumCli = findViewById(R.id.tvNumcliModif);
            EditText etDateTime = findViewById(R.id.tvDateModif);
            EditText etObservation = findViewById(R.id.tvObsModif);

            // Remplir les EditText
            etNumCli.setText(numCLient);
            etDateTime.setText(date);
            etObservation.setText(observation);
        }
    }
    public void supprimerIntervention(){
        InterventionDAO intervention = new InterventionDAO(this);
        intervention.deleteIntervention(idInter); // appel de la methode presente dans ClientDAO
        intervention.close(); //fermer la classe
        Toast.makeText(this, "Intervention supprimé", Toast.LENGTH_SHORT).show();

    }



    public void modifierIntervention(){
        // On récupère les champs de texte (les EditText) à l'écran, où l'utilisateur a tapé les infos
        EditText etNumCli = findViewById(R.id.tvNumcliModif);
        EditText etDateTime = findViewById(R.id.tvDateModif);
        EditText etObservation = findViewById(R.id.tvObsModif);

        // On transforme le texte saisi par l'utilisateur (EditText) en vraie chaîne de caractères (String)
        // C’est ce qu’on va envoyer à la base de données
        String idClient = etNumCli.getText().toString();
        String date = etDateTime.getText().toString();
        String observation = etObservation.getText().toString();

        // On crée une instance de ClientDAO pour accéder à la base de données
        InterventionDAO interventionDAO = new InterventionDAO(this);

        // On appelle la méthode updateClient avec toutes les nouvelles valeurs + l'ID du client
        interventionDAO.updateIntervention( idInter, Integer.parseInt(idClient), date, observation );

        // On ferme la connexion à la base de données pour libérer les ressources
        interventionDAO.close();

        Toast.makeText(this, "intervention modifiée", Toast.LENGTH_SHORT).show();

        // On ferme cette activité et on revient à l'écran précédent (ex : la liste des clients)
        finish(); // retour à la liste

    }


}